<?php
/*
	Le prix d'un produit est assez difficile  dterminer
	En effet, il dpend de son prix normal, mais aussi du taux des promotions potentielles
	Il existe deux types de promotions (2 tables diffrentes) :
		* les promo exceptionnelles
		* les promo groupes
*/

// Si le prix est en promotion ou pas
define("PRIX_NORMAL", 0);
define("PRIX_PROMO", 1);

// Les index du tableau de retour
define("IDX_PRIX", "prix");
define("IDX_TYPE", "type");
define("IDX_EX", "ex_prix");

function getProduitPrix($bd, $idProduit, $date)
{
	$prixParDefaut = $bd->getOneRow("SELECT * FROM prix WHERE produit='$idProduit' AND "
		. "dateDebPrix<='$date' AND dateFinPrix>='$date'");
	
	/* Si on ne trouve pas de prix, on renvoi 0 */
	if(empty($prixParDefaut))
		return (Array(IDX_PRIX => 0, IDX_TYPE => PRIX_NORMAL, IDX_EX => 0));

	/* Recherche de promo isole */
	$prixPromo = $bd->getOneRow("SELECT * FROM promotion WHERE prix_produit='".$prixParDefaut->numPrix."' AND "
		. "dateDebPromo<='$date' AND dateFinPromo>='$date'");
	if(! empty($prixPromo))
		return (Array(IDX_PRIX => ($prixParDefaut->prixEuros)*(1-$prixPromo->tauxPromo), IDX_TYPE => PRIX_PROMO, IDX_EX => $prixParDefaut->prixEuros));

	/* Recherche de promo groupe */
	$prixPromo = $bd->getOneRow("SELECT * FROM promo_groupe, campagne WHERE campagne=numCampagne AND "
		. "prix_produit='".$prixParDefaut->numPrix."' AND "
		. "dateDebCampagne<='$date' AND dateFinCampagne>='$date'");
	if(! empty($prixPromo))
		return (Array(IDX_PRIX => ($prixParDefaut->prixEuros)*(1-$prixPromo->taux), IDX_TYPE => PRIX_PROMO, IDX_EX => $prixParDefaut->prixEuros));
	
	return (Array(IDX_PRIX => $prixParDefaut->prixEuros, IDX_TYPE => PRIX_NORMAL, IDX_EX => $prixParDefaut->prixEuros));
}


?>