<?php
	//include_once($_SERVER['DOCUMENT_ROOT']."/FCT/ctrlAcces.php");

class acces_bd
{

	var $host = "localhost";
	var $base = "nf17";
	var $user = "root";
	var $passwd = "";

	var $idConnect = 0;				//identifiant de la connexion au serveur
	var $etatBase = 0;				//etat de la connexion  la base de donnes
	var $idResult = 0;
	
	var $ligne = 0;					//dernire ligne parcourue dans les rsultats de la dernire requte
	var $nbLignes = 0;				//nombres de lignes non parcourues dans le rssultat courant

	function acces_bd()
	{
		$this->connect();
	}

	/********************************************************
		Les mthodes :

		connect() -> Ouvre une connexion  la base de donnes

		deconnect() -> Ferme la connexion  la base de donnes

		requete($req) -> Lance la requte $req sur la bd : retourne vrai si russie

		suivant() -> retourne la ligne courante du rsultat puis avance d'une ligne, retourne 0 si plus de rsultats

		getNbLignes() -> retourne le nombre de lignes restantes dans le rsultat

		update($req) -> Lance une requte du type INSERT/UPDATE/DELETE, mais sans interfrer avec une dj en cours

		getOneRow($req) -> Lance une requete (qui renvoi une seule ligne), mais sans interfrer avec une dj en cours

		getField($req, $field) -> Lance une requete (qui renvoi un seul champ), mais sans interfrer avec une dj en cours

	*********************************************************/

//Connexion au serveur sur la base $base
	function connect()
	{
		if(! $this->idConnect)
		{
			//Connexion au serveur de bases de donnes
			$this->idConnect = mysql_connect($this->host, $this->user, $this->passwd)
				or die("Erreur de connexion au serveur de bases de donnes.");
			
			//slection de la base
			$this->etatBase = mysql_select_db($this->base)
				or die("Erreur de connexion  la base de donnes");
		}
	}

//Dconnecte du serveur
	function deconnect()
	{
		@mysql_close();
		$this->idConnect 	= false;
		$this->etatBase  	= false;
	}

//Lance une requte sur la base de donnes retourne vrai si russie, sinon retourne faux
	function requete($req = "")
	{
		//Si on est connect au serveur
		if($this->idConnect)
		{
			//Si on est connect  la base de donnes
			if($this->etatBase)
			{
				$this->idResult = mysql_query($req, $this->idConnect);
				if( $this->idResult )
				{
					$this->nbLignes = @mysql_num_rows($this->idResult);
					$this->ligne = 0;
					return true;
				}
			}
		}
		return false;
	}


//Pour avancer au rsultat suivant
//Retourne le contenu de la ligne courante (vaut 0 si plus de rsultats)
	function suivant()
	{
		//Si il reste des rsultats  parcourir
		if( $this->nbLignes )
		{
			$this->ligne = mysql_fetch_object($this->idResult);
			$this->nbLignes--;
		}
		else
			$this->ligne = 0;
				
		return($this->ligne);
	}
	
//Retourne le nombre de lignes non parcourues dans le rsultat
//Correspond au nombre total de lignes du rsultat si la mthode suivant 
//n'a pas t appele depuis l'xcution de la dernire requte
	function getNbLignes()
	{
		return $this->nbLignes;
	}
	



//Lance une requte du type : INSERT/UPDATE/DELETE
	function update($req = "")
	{
		//Si on est connect au serveur
		if($this->idConnect)
		{
			//Si on est connect  la base de donnes
			if($this->etatBase)
			{
				if ( mysql_query($req, $this->idConnect) )
					return true;
			}
		}
		return false;
	}	

//Lance une requte sur la base de donnes et retourne une seule ligne
	function getOneRow($req = "")
	{
		//Si on est connect au serveur
		if($this->idConnect)
			//Si on est connect  la base de donnes
			if($this->etatBase)
				if( $res = mysql_query($req, $this->idConnect) )
					return mysql_fetch_object($res);
		return false;
	}	


//Lance une requte sur la base de donnes et retourne un seul champ
	function getField($req, $field = "")
	{
		if((empty($field)) )
		{
			/** recherche de Field dans la requete */
			$req = trim($req);
			$arr = explode("FROM", strtoupper($req));
			if (sizeOf($arr) != 2)
				return false;
			$arr[0] = substr($req,0,strlen($arr[0]));
			if (substr(strtoupper($arr[0]),0,6) != "SELECT")
				return false;
			$field = trim(substr($arr[0],7,strlen($arr[0])-6));
			$arr = explode(" ", $field);
			if (sizeof($arr)==1)
				$field = $arr[0];
			elseif (sizeof($arr)==3 && trim(strtoupper($arr[1])) == "AS")
				$field = $arr[2];
			else
				return false;
		}
		
		$ret = $this->getOneRow($req);
		if (isset($ret->$field))
			return $ret->$field;
		return false;
	}
	
// Rcupre l'id du dernier auto_incremente utilis
	function getAutoInc()
	{
		return mysql_insert_id();
	}
}

	$bd = new acces_bd;

?>