-- phpMyAdmin SQL Dump
-- version 2.8.0.3
-- http://www.phpmyadmin.net
-- 
-- Serveur: localhost
-- Généré le : Mardi 13 Juin 2006 à 22:15
-- Version du serveur: 5.0.21
-- Version de PHP: 5.1.4
-- 
-- Base de données: `nf17`
-- 

-- --------------------------------------------------------

-- 
-- Structure de la table `campagne`
-- 
DROP TABLE IF EXISTS `campagne`;
CREATE TABLE `campagne` (
  `numCampagne` int(11) NOT NULL auto_increment,
  `nomCampagne` text NOT NULL,
  `dateDebCampagne` date NOT NULL default '0000-00-00',
  `dateFinCampagne` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`numCampagne`)
) AUTO_INCREMENT=2 ;

-- 
-- Contenu de la table `campagne`
-- 

INSERT INTO `campagne` VALUES (1, 'Campagne de test', '0000-00-00', '2006-10-10');

-- --------------------------------------------------------

-- 
-- Structure de la table `categorie`
-- 
DROP TABLE IF EXISTS `categorie`;
CREATE TABLE `categorie` (
  `numCategorie` int(11) NOT NULL auto_increment,
  `nomCategorie` text NOT NULL,
  `idPere` int(11) default NULL,
  `imageCategorie` text NOT NULL,
  `visible` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`numCategorie`)
) AUTO_INCREMENT=35 ;

-- 
-- Contenu de la table `categorie`
-- 

INSERT INTO `categorie` VALUES (1, 'Panier et vannerie', NULL, 'r_371_7.jpg', 1);
INSERT INTO `categorie` VALUES (2, 'Le bureau', NULL, 'r_37_2.jpg', 1);
INSERT INTO `categorie` VALUES (3, 'La musique', NULL, 'r_60_1.jpg', 1);
INSERT INTO `categorie` VALUES (4, 'La papeterie', NULL, 'r_62_1.jpg', 1);
INSERT INTO `categorie` VALUES (5, 'Les bijoux', NULL, 'r_55_3.jpg', 1);
INSERT INTO `categorie` VALUES (6, 'Jeux et jouets', NULL, 'r_21_3.jpg', 1);
INSERT INTO `categorie` VALUES (7, 'La maison', NULL, 'r_44_3.jpg', 1);
INSERT INTO `categorie` VALUES (8, 'Alimentaire', NULL, 'r_16_5.jpg', 1);
INSERT INTO `categorie` VALUES (9, 'Catalogue 2005-2006', NULL, 'r_377.jpg', 1);
INSERT INTO `categorie` VALUES (10, 'Le jardin', NULL, 'r_372_4.jpg', 1);
INSERT INTO `categorie` VALUES (11, 'Le textile', NULL, 'r_369_4.jpg', 1);
INSERT INTO `categorie` VALUES (12, 'Les soins du corps', NULL, 'r_63_4.jpg', 1);
INSERT INTO `categorie` VALUES (13, 'Les instruments', 3, '477_1.jpg', 1);
INSERT INTO `categorie` VALUES (14, 'Range CD', 3, '491.jpg', 1);
INSERT INTO `categorie` VALUES (15, 'Jeux et musique printemps', 3, '518.jpg', 1);

-- --------------------------------------------------------

-- 
-- Structure de la table `cmd_produit`
-- 
DROP TABLE IF EXISTS `cmd_produit`;
CREATE TABLE `cmd_produit` (
  `livraison` int(11) NOT NULL default '0',
  `produit` int(11) NOT NULL default '0',
  `quantite` int(11) default NULL,
  `prix` double default NULL,
  PRIMARY KEY  (`livraison`,`produit`)
);

-- 
-- Contenu de la table `cmd_produit`
-- 

INSERT INTO `cmd_produit` VALUES (1, 1, 15, 120);
INSERT INTO `cmd_produit` VALUES (1, 3, 120, 46);

-- --------------------------------------------------------

-- 
-- Structure de la table `fournisseur`
-- 
DROP TABLE IF EXISTS `fournisseur`;
CREATE TABLE `fournisseur` (
  `numFournisseur` smallint(6) NOT NULL auto_increment,
  `nomFournisseur` varchar(50) NOT NULL default '',
  `paysFournisseur` text NOT NULL,
  PRIMARY KEY  (`numFournisseur`),
  UNIQUE KEY `nomFournisseur` (`nomFournisseur`)
) AUTO_INCREMENT=2 ;

-- 
-- Contenu de la table `fournisseur`
-- 

INSERT INTO `fournisseur` VALUES (1, 'Noah''s Ark', 'inde');

-- --------------------------------------------------------

-- 
-- Structure de la table `info_prod`
-- 
DROP TABLE IF EXISTS `info_prod`;
CREATE TABLE `info_prod` (
  `numInfo` bigint(20) NOT NULL auto_increment,
  `produit` int(11) NOT NULL default '0',
  `nomChamp` text NOT NULL,
  `information` text NOT NULL,
  PRIMARY KEY  (`numInfo`)
) AUTO_INCREMENT=2 ;

-- 
-- Contenu de la table `info_prod`
-- 

INSERT INTO `info_prod` VALUES (1, 1, 'Dimension', '15x15x14cm');

-- --------------------------------------------------------

-- 
-- Structure de la table `livraison`
-- 
DROP TABLE IF EXISTS `livraison`;
CREATE TABLE `livraison` (
  `numLivraison` int(11) NOT NULL auto_increment,
  `fournisseur` int(11) default NULL,
  `date` date NOT NULL,
  PRIMARY KEY  (`numLivraison`)
) AUTO_INCREMENT=1 ;

-- 
-- Contenu de la table `livraison`
-- 


-- --------------------------------------------------------

-- 
-- Structure de la table `prix`
-- 
DROP TABLE IF EXISTS `prix`;
CREATE TABLE `prix` (
  `numPrix` bigint(20) NOT NULL auto_increment,
  `produit` int(11) NOT NULL default '0',
  `dateDebPrix` date NOT NULL default '0000-00-00',
  `dateFinPrix` date NOT NULL default '0000-00-00',
  `prixEuros` float NOT NULL default '0',
  PRIMARY KEY  (`numPrix`)
) AUTO_INCREMENT=5 ;

-- 
-- Contenu de la table `prix`
-- 

INSERT INTO `prix` VALUES (1, 1, '0000-00-00', '2006-10-01', 11.9);
INSERT INTO `prix` VALUES (2, 2, '0000-00-00', '2006-10-01', 19.9);
INSERT INTO `prix` VALUES (3, 3, '0000-00-00', '2006-10-01', 28.9);
INSERT INTO `prix` VALUES (4, 4, '0000-00-00', '2006-10-01', 16.5);

-- --------------------------------------------------------

-- 
-- Structure de la table `produit`
-- 
DROP TABLE IF EXISTS `produit`;
CREATE TABLE `produit` (
  `numProduit` int(11) NOT NULL auto_increment,
  `refProduit` varchar(6) NOT NULL default '',
  `nomProduit` text NOT NULL,
  `descrProduit` text NOT NULL,
  `imageProduit` text NOT NULL,
  `categorie` int(11) NOT NULL default '0',
  `fournisseur` smallint(6) NOT NULL default '0',
  `visible` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`numProduit`),
  UNIQUE KEY `refProduit` (`refProduit`),
  FULLTEXT KEY `refProduit_2` (`refProduit`)
) AUTO_INCREMENT=20 ;

-- 
-- Contenu de la table `produit`
-- 

INSERT INTO `produit` VALUES (1, '24251A', 'Range CD un Compartiment', 'Range CD 1 compartiment. Les compartiments en carré permettent de placer les range CD et les CD de manière horizontale ou verticale. En bois de Sesham massif incrusté de motifs en laiton.', 'boutique_artisan_du_monde_v_24251A.jpg', 14, 1, 1);
INSERT INTO `produit` VALUES (2, '24252A', 'Range CD deux Compartiments', '', 'boutique_artisan_du_monde_v_24252A.jpg', 14, 1, 1);
INSERT INTO `produit` VALUES (3, '24253A', 'Range CD Trois Compartiments', '', 'boutique_artisan_du_monde_v_24253A.jpg', 14, 1, 1);

-- --------------------------------------------------------

-- 
-- Structure de la table `produit_panier`
-- 
DROP TABLE IF EXISTS `produit_panier`;
CREATE TABLE `produit_panier` (
  `produit` bigint(20) NOT NULL default '0',
  `panier` bigint(20) NOT NULL default '0',
  `nombre` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`produit`,`panier`)
);

-- 
-- Contenu de la table `produit_panier`
-- 


-- --------------------------------------------------------

-- 
-- Structure de la table `promo_groupe`
-- 
DROP TABLE IF EXISTS `promo_groupe`;
CREATE TABLE `promo_groupe` (
  `prix_produit` bigint(20) NOT NULL default '0',
  `campagne` int(11) NOT NULL default '0',
  `taux` float NOT NULL default '0',
  PRIMARY KEY  (`prix_produit`,`campagne`)
);

-- 
-- Contenu de la table `promo_groupe`
-- 

INSERT INTO `promo_groupe` VALUES (3, 1, 0.2);

-- --------------------------------------------------------

-- 
-- Structure de la table `promotion`
-- 
DROP TABLE IF EXISTS `promotion`;
CREATE TABLE `promotion` (
  `numPromotion` bigint(20) NOT NULL auto_increment,
  `prix_produit` bigint(20) NOT NULL default '0',
  `dateDebPromo` date NOT NULL default '0000-00-00',
  `dateFinPromo` date NOT NULL default '0000-00-00',
  `tauxPromo` float NOT NULL default '0',
  PRIMARY KEY  (`numPromotion`)
) AUTO_INCREMENT=2 ;

-- 
-- Contenu de la table `promotion`
-- 

INSERT INTO `promotion` VALUES (1, 2, '0000-00-00', '2006-10-10', 0.2);
